diff --git a/libgcc/config/libbid/bid64_div.c b/libgcc/config/libbid/bid64_div.c
old mode 100755
new mode 100644
index 7f34556c6d6..69758482b89
--- a/libgcc/config/libbid/bid64_div.c
+++ b/libgcc/config/libbid/bid64_div.c
@@ -55,8 +55,9 @@ see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
 
 #include "bid_internal.h"
 #include "bid_div_macros.h"
-#include <fenv.h>
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
+#include <fenv.h>
+
 #define FE_ALL_FLAGS FE_INVALID|FE_DIVBYZERO|FE_OVERFLOW|FE_UNDERFLOW|FE_INEXACT
 #endif
 
@@ -64,6 +65,7 @@ extern UINT32 convert_table[5][128][2];
 extern SINT8 factors[][2];
 extern UINT8 packed_10000_zeros[];
 
+
 #if DECIMAL_CALL_BY_REFERENCE
 
 void
@@ -92,7 +94,6 @@ bid64_div (UINT64 x,
   int rmode, amount;
   int nzeros, i, j, k, d5;
   UINT32 QX32, tdigit[3], digit, digit_h, digit_low;
-  int old_rm, rm_changed=0;
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
   fexcept_t binaryflags = 0;
 #endif
@@ -105,12 +106,6 @@ bid64_div (UINT64 x,
   y = *py;
 #endif
 
-  // Set it to round-to-nearest (if different)
-  if ((old_rm=fegetround()) != FE_TONEAREST) {
-    rm_changed=1;
-    fesetround(FE_TONEAREST);
-  }
-
   valid_x = unpack_BID64 (&sign_x, &exponent_x, &coefficient_x, x);
   valid_y = unpack_BID64 (&sign_y, &exponent_y, &coefficient_y, y);
 
@@ -128,8 +123,6 @@ bid64_div (UINT64 x,
       if ((x & SNAN_MASK64) == SNAN_MASK64)	// sNaN
 	__set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (coefficient_x & QUIET_MASK64);
     }
     // x is Infinity?
@@ -141,14 +134,10 @@ bid64_div (UINT64 x,
 #ifdef SET_STATUS_FLAGS
 	  __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
-          // restore the rounding mode back if it has been changed
-          if (rm_changed) fesetround(old_rm);
 	  BID_RETURN (NAN_MASK64);
 	}
       } else {
 	// otherwise return +/-Inf
-        // restore the rounding mode back if it has been changed
-        if (rm_changed) fesetround(old_rm);
 	BID_RETURN (((x ^ y) & 0x8000000000000000ull) |
 		    INFINITY_MASK64);
       }
@@ -160,8 +149,6 @@ bid64_div (UINT64 x,
 #ifdef SET_STATUS_FLAGS
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (NAN_MASK64);
     }
     if (((y & INFINITY_MASK64) != INFINITY_MASK64)) {
@@ -176,8 +163,6 @@ bid64_div (UINT64 x,
 	exponent_x = DECIMAL_MAX_EXPON_64;
       else if (exponent_x < 0)
 	exponent_x = 0;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN ((sign_x ^ sign_y) | (((UINT64) exponent_x) << 53));
     }
 
@@ -191,23 +176,17 @@ bid64_div (UINT64 x,
       if ((y & SNAN_MASK64) == SNAN_MASK64)	// sNaN
 	__set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (coefficient_y & QUIET_MASK64);
     }
     // y is Infinity?
     if ((y & INFINITY_MASK64) == INFINITY_MASK64) {
       // return +/-0
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (((x ^ y) & 0x8000000000000000ull));
     }
     // y is 0
 #ifdef SET_STATUS_FLAGS
     __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN ((sign_x ^ sign_y) | INFINITY_MASK64);
   }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -276,8 +255,6 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
     // get decimal digits of Q
@@ -447,8 +424,6 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
   }
@@ -519,8 +494,6 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -537,8 +510,6 @@ bid64_div (UINT64 x,
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
 
   }
@@ -557,17 +528,10 @@ int exponent_x, exponent_y, bin_index, bin_expon, diff_expon, ed2,
   digits_q, amount;
 int nzeros, i, j, k, d5, done = 0;
 unsigned rmode;
-int old_rm, rm_changed=0;
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
 fexcept_t binaryflags = 0;
 #endif
 
-// Set it to round-to-nearest (if different)
-if ((old_rm=fegetround()) != FE_TONEAREST) {
-  rm_changed=1;
-  fesetround(FE_TONEAREST);
-}
-
 valid_y = unpack_BID128_value (&sign_y, &exponent_y, &CY, y);
 
 	// unpack arguments, check for NaN or Infinity
@@ -581,8 +545,6 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
   // test if x is NaN
   if (((x) & 0x7c00000000000000ull) == 0x7c00000000000000ull) {
     res = CX.w[0];
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res & QUIET_MASK64);
   }
   // x is Infinity?
@@ -595,18 +557,14 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
-    }
-    if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
-      // otherwise return +/-Inf
-      res =
-	(((x) ^ y.w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
+	if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
+    // otherwise return +/-Inf
+    res =
+      (((x) ^ y.w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
+    BID_RETURN (res);
+	}
   }
   // x is 0
   if ((y.w[1] & INFINITY_MASK64) != INFINITY_MASK64) {
@@ -616,8 +574,6 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
 #endif
       // x=y=0, return NaN
       res = 0x7c00000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
     // return 0
@@ -628,8 +584,6 @@ if (!unpack_BID64 (&sign_x, &exponent_x, &CX.w[0], (x))) {
     else if (exponent_x < 0)
       exponent_x = 0;
     res |= (((UINT64) exponent_x) << 53);
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
 }
@@ -650,16 +604,12 @@ if (!valid_y) {
     amount = recip_scale[18];
     __shr_128 (Tmp, Qh, amount);
     res = (CY.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is Infinity?
   if ((y.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
     // return +/-0
     res = sign_x ^ sign_y;
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is 0, return +/-Inf
@@ -668,8 +618,6 @@ if (!valid_y) {
 #ifdef SET_STATUS_FLAGS
   __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
-  // restore the rounding mode back if it has been changed
-  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
 }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -732,8 +680,6 @@ if (__unsigned_compare_gt_128 (CY, CX)) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
 
@@ -870,17 +816,15 @@ if (!done) {
 
       }
     }
-    if(diff_expon>=0){
-      res =
-	fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
-				 rnd_mode, pfpsf);
+	if(diff_expon>=0){
+    res =
+      fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
+			       rnd_mode, pfpsf);
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
-    }
+    BID_RETURN (res);
+	}
   }
 #endif
 
@@ -961,8 +905,6 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -979,9 +921,8 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
+
   }
 
 }
@@ -1001,18 +942,10 @@ int exponent_x, exponent_y, bin_index, bin_expon, diff_expon, ed2,
   digits_q, amount;
 int nzeros, i, j, k, d5, done = 0;
 unsigned rmode;
-int old_rm, rm_changed=0;
-
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
 fexcept_t binaryflags = 0;
 #endif
 
-// Set it to round-to-nearest (if different)
-if ((old_rm=fegetround()) != FE_TONEAREST) {
-  rm_changed=1;
-  fesetround(FE_TONEAREST);
-}
-
 valid_y = unpack_BID64 (&sign_y, &exponent_y, &CY.w[0], (y));
 
 	// unpack arguments, check for NaN or Infinity
@@ -1031,9 +964,7 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       amount = recip_scale[18];
       __shr_128 (Tmp, Qh, amount);
       res = (CX.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
+    BID_RETURN (res);
   }
   // x is Infinity?
   if ((x.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
@@ -1045,18 +976,14 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
-    }
-    if (((y & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
-      // otherwise return +/-Inf
-      res =
-	((x.w[1] ^ (y)) & 0x8000000000000000ull) | 0x7800000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
+	if (((y & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
+    // otherwise return +/-Inf
+    res =
+      ((x.w[1] ^ (y)) & 0x8000000000000000ull) | 0x7800000000000000ull;
+    BID_RETURN (res);
+	}
   }
   // x is 0
   if (((y & INFINITY_MASK64) != INFINITY_MASK64) &&
@@ -1066,21 +993,17 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
 #endif
     // x=y=0, return NaN
     res = 0x7c00000000000000ull;
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // return 0
   if (((y & 0x7800000000000000ull) != 0x7800000000000000ull)) {
-    if (!CY.w[0]) {
+	  if (!CY.w[0]) {
 #ifdef SET_STATUS_FLAGS
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
-    }
+	  }
     exponent_x =
       exponent_x - exponent_y - DECIMAL_EXPONENT_BIAS_128 +
       (DECIMAL_EXPONENT_BIAS << 1);
@@ -1089,8 +1012,6 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
     else if (exponent_x < 0)
       exponent_x = 0;
     res = (sign_x ^ sign_y) | (((UINT64) exponent_x) << 53);
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
 }
@@ -1104,16 +1025,12 @@ if (!valid_y) {
     if ((y & SNAN_MASK64) == SNAN_MASK64)	// sNaN
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (CY.w[0] & QUIET_MASK64);
   }
   // y is Infinity?
   if (((y) & 0x7800000000000000ull) == 0x7800000000000000ull) {
     // return +/-0
     res = sign_x ^ sign_y;
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is 0, return +/-Inf
@@ -1122,8 +1039,6 @@ if (!valid_y) {
 #ifdef SET_STATUS_FLAGS
   __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
-  // restore the rounding mode back if it has been changed
-  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
 }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -1188,8 +1103,6 @@ if (__unsigned_compare_gt_128 (CY, CX)) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
 
@@ -1246,104 +1159,102 @@ if (!done) {
 #endif
 #ifndef LEAVE_TRAILING_ZEROS
     // check whether result is exact
-    {
-      if(!done) {
-	// check whether CX, CY are short
-	if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
-	  i = (int) CY.w[0] - 1;
-	  j = (int) CX.w[0] - 1;
-	  // difference in powers of 2 factors for Y and X
-	  nzeros = ed2 - factors[i][0] + factors[j][0];
-	  // difference in powers of 5 factors
-	  d5 = ed2 - factors[i][1] + factors[j][1];
-	  if (d5 < nzeros)
-	    nzeros = d5;
+  {
+	  if(!done) {
+    // check whether CX, CY are short
+    if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
+      i = (int) CY.w[0] - 1;
+      j = (int) CX.w[0] - 1;
+      // difference in powers of 2 factors for Y and X
+      nzeros = ed2 - factors[i][0] + factors[j][0];
+      // difference in powers of 5 factors
+      d5 = ed2 - factors[i][1] + factors[j][1];
+      if (d5 < nzeros)
+		nzeros = d5;
+      // get P*(2^M[extra_digits])/10^extra_digits
+      __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
+      //__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
+
+      // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
+      amount = recip_scale[nzeros];
+      __shr_128_long (CQ, Qh, amount);
+
+      diff_expon += nzeros;
+    } else {
+      // decompose Q as Qh*10^17 + Ql
+      //T128 = reciprocals10_128[17];
+      Q_low = CQ.w[0];
+
+      {
+	tdigit[0] = Q_low & 0x3ffffff;
+	tdigit[1] = 0;
+	QX = Q_low >> 26;
+	QX32 = QX;
+	nzeros = 0;
+
+	for (j = 0; QX32; j++, QX32 >>= 7) {
+	  k = (QX32 & 127);
+	  tdigit[0] += convert_table[j][k][0];
+	  tdigit[1] += convert_table[j][k][1];
+	  if (tdigit[0] >= 100000000) {
+	    tdigit[0] -= 100000000;
+	    tdigit[1]++;
+	  }
+	}
+
+	if (tdigit[1] >= 100000000) {
+	  tdigit[1] -= 100000000;
+	  if (tdigit[1] >= 100000000)
+	    tdigit[1] -= 100000000;
+	}
+
+	digit = tdigit[0];
+	if (!digit && !tdigit[1])
+	  nzeros += 16;
+	else {
+	  if (!digit) {
+	    nzeros += 8;
+	    digit = tdigit[1];
+	  }
+	  // decompose digit
+	  PD = (UINT64) digit *0x068DB8BBull;
+	  digit_h = (UINT32) (PD >> 40);
+	  digit_low = digit - digit_h * 10000;
+
+	  if (!digit_low)
+	    nzeros += 4;
+	  else
+	    digit_h = digit_low;
+
+	  if (!(digit_h & 1))
+	    nzeros +=
+	      3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
+			    (digit_h & 7));
+	}
+
+	if (nzeros) {
 	  // get P*(2^M[extra_digits])/10^extra_digits
 	  __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
-	  //__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
 
 	  // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
 	  amount = recip_scale[nzeros];
-	  __shr_128_long (CQ, Qh, amount);
-
-	  diff_expon += nzeros;
-	} else {
-	  // decompose Q as Qh*10^17 + Ql
-	  //T128 = reciprocals10_128[17];
-	  Q_low = CQ.w[0];
-
-	  {
-	    tdigit[0] = Q_low & 0x3ffffff;
-	    tdigit[1] = 0;
-	    QX = Q_low >> 26;
-	    QX32 = QX;
-	    nzeros = 0;
-
-	    for (j = 0; QX32; j++, QX32 >>= 7) {
-	      k = (QX32 & 127);
-	      tdigit[0] += convert_table[j][k][0];
-	      tdigit[1] += convert_table[j][k][1];
-	      if (tdigit[0] >= 100000000) {
-		tdigit[0] -= 100000000;
-		tdigit[1]++;
-	      }
-	    }
-
-	    if (tdigit[1] >= 100000000) {
-	      tdigit[1] -= 100000000;
-	      if (tdigit[1] >= 100000000)
-		tdigit[1] -= 100000000;
-	    }
-
-	    digit = tdigit[0];
-	    if (!digit && !tdigit[1])
-	      nzeros += 16;
-	    else {
-	      if (!digit) {
-		nzeros += 8;
-		digit = tdigit[1];
-	      }
-	      // decompose digit
-	      PD = (UINT64) digit *0x068DB8BBull;
-	      digit_h = (UINT32) (PD >> 40);
-	      digit_low = digit - digit_h * 10000;
-
-	      if (!digit_low)
-		nzeros += 4;
-	      else
-		digit_h = digit_low;
-
-	      if (!(digit_h & 1))
-		nzeros +=
-		  3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
-				(digit_h & 7));
-	    }
-	
-	    if (nzeros) {
-	      // get P*(2^M[extra_digits])/10^extra_digits
-	      __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
-
-	      // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
-	      amount = recip_scale[nzeros];
-	      __shr_128 (CQ, Qh, amount);
-	    }
-	    diff_expon += nzeros;
-
-	  }
+	  __shr_128 (CQ, Qh, amount);
 	}
-      }
-      if(diff_expon>=0){
-	res =
-	  fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
-				   rnd_mode, pfpsf);
-#ifdef UNCHANGED_BINARY_STATUS_FLAGS
-	(void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
-#endif
-        // restore the rounding mode back if it has been changed
-	if (rm_changed) fesetround(old_rm);
-	BID_RETURN (res);
+	diff_expon += nzeros;
+
       }
     }
+	  }
+	if(diff_expon>=0){
+    res =
+      fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
+			       rnd_mode, pfpsf);
+#ifdef UNCHANGED_BINARY_STATUS_FLAGS
+    (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
+#endif
+    BID_RETURN (res);
+	}
+  }
 #endif
 
   if (diff_expon >= 0) {
@@ -1426,8 +1337,6 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -1444,9 +1353,8 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
+
   }
 
 }
@@ -1471,17 +1379,10 @@ int exponent_x, exponent_y, bin_index, bin_expon, diff_expon, ed2,
   digits_q, amount;
 int nzeros, i, j, k, d5, done = 0;
 unsigned rmode;
-int old_rm, rm_changed=0;
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
 fexcept_t binaryflags = 0;
 #endif
 
-// Set it to round-to-nearest (if different)
-if ((old_rm=fegetround()) != FE_TONEAREST) {
-  rm_changed=1;
-  fesetround(FE_TONEAREST);
-}
-
 valid_y = unpack_BID128_value (&sign_y, &exponent_y, &CY, y);
 
 	// unpack arguments, check for NaN or Infinity
@@ -1500,9 +1401,7 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       amount = recip_scale[18];
       __shr_128 (Tmp, Qh, amount);
       res = (CX.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
+    BID_RETURN (res);
   }
   // x is Infinity?
   if ((x.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
@@ -1514,19 +1413,15 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
       __set_status_flags (pfpsf, INVALID_EXCEPTION);
 #endif
       res = 0x7c00000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
-    }
-    if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
-      // otherwise return +/-Inf
-      res =
-	((x.w[1] ^ y.
-	  w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
+	if (((y.w[1] & 0x7c00000000000000ull) != 0x7c00000000000000ull)) {
+    // otherwise return +/-Inf
+    res =
+      ((x.w[1] ^ y.
+	w[1]) & 0x8000000000000000ull) | 0x7800000000000000ull;
+    BID_RETURN (res);
+	}
   }
   // x is 0
   if (((y.w[1] & 0x7800000000000000ull) != 0x7800000000000000ull)) {
@@ -1536,8 +1431,6 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
 #endif
     // x=y=0, return NaN
     res = 0x7c00000000000000ull;
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // return 0
@@ -1548,8 +1441,6 @@ if (!unpack_BID128_value (&sign_x, &exponent_x, &CX, x)) {
   else if (exponent_x < 0)
     exponent_x = 0;
   res |= (((UINT64) exponent_x) << 53);
-  // restore the rounding mode back if it has been changed
-  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
   }
 }
@@ -1569,16 +1460,12 @@ if (!valid_y) {
       amount = recip_scale[18];
       __shr_128 (Tmp, Qh, amount);
       res = (CY.w[1] & 0xfc00000000000000ull) | Tmp.w[0];
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
+    BID_RETURN (res);
   }
   // y is Infinity?
   if ((y.w[1] & 0x7800000000000000ull) == 0x7800000000000000ull) {
     // return +/-0
     res = sign_x ^ sign_y;
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   }
   // y is 0, return +/-Inf
@@ -1587,8 +1474,6 @@ if (!valid_y) {
 #ifdef SET_STATUS_FLAGS
   __set_status_flags (pfpsf, ZERO_DIVIDE_EXCEPTION);
 #endif
-  // restore the rounding mode back if it has been changed
-  if (rm_changed) fesetround(old_rm);
   BID_RETURN (res);
 }
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
@@ -1651,8 +1536,6 @@ if (__unsigned_compare_gt_128 (CY, CX)) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
       (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
       BID_RETURN (res);
     }
 
@@ -1711,102 +1594,100 @@ if (!done) {
 #ifndef LEAVE_TRAILING_ZEROS
     // check whether result is exact
   {
-    if(!done) {
-      // check whether CX, CY are short
-      if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
-	i = (int) CY.w[0] - 1;
-	j = (int) CX.w[0] - 1;
-	// difference in powers of 2 factors for Y and X
-	nzeros = ed2 - factors[i][0] + factors[j][0];
-	// difference in powers of 5 factors
-	d5 = ed2 - factors[i][1] + factors[j][1];
-	if (d5 < nzeros)
-	  nzeros = d5;
-	// get P*(2^M[extra_digits])/10^extra_digits
-	__mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
-	//__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
-	
-	// now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
-	amount = recip_scale[nzeros];
-	__shr_128_long (CQ, Qh, amount);
-	
-	diff_expon += nzeros;
-      } else {
-	// decompose Q as Qh*10^17 + Ql
-	//T128 = reciprocals10_128[17];
-	Q_low = CQ.w[0];
-      
-	{
-	  tdigit[0] = Q_low & 0x3ffffff;
-	  tdigit[1] = 0;
-	  QX = Q_low >> 26;
-	  QX32 = QX;
-	  nzeros = 0;
+	  if(!done) {
+    // check whether CX, CY are short
+    if (!CX.w[1] && !CY.w[1] && (CX.w[0] <= 1024) && (CY.w[0] <= 1024)) {
+      i = (int) CY.w[0] - 1;
+      j = (int) CX.w[0] - 1;
+      // difference in powers of 2 factors for Y and X
+      nzeros = ed2 - factors[i][0] + factors[j][0];
+      // difference in powers of 5 factors
+      d5 = ed2 - factors[i][1] + factors[j][1];
+      if (d5 < nzeros)
+	nzeros = d5;
+      // get P*(2^M[extra_digits])/10^extra_digits
+      __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
+      //__mul_128x128_to_256(P256, CQ, reciprocals10_128[nzeros]);Qh.w[1]=P256.w[3];Qh.w[0]=P256.w[2];
 
-	  for (j = 0; QX32; j++, QX32 >>= 7) {
-	    k = (QX32 & 127);
-	    tdigit[0] += convert_table[j][k][0];
-	    tdigit[1] += convert_table[j][k][1];
-	    if (tdigit[0] >= 100000000) {
-	      tdigit[0] -= 100000000;
-	      tdigit[1]++;
-	    }
+      // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
+      amount = recip_scale[nzeros];
+      __shr_128_long (CQ, Qh, amount);
+
+      diff_expon += nzeros;
+    } else {
+      // decompose Q as Qh*10^17 + Ql
+      //T128 = reciprocals10_128[17];
+      Q_low = CQ.w[0];
+
+      {
+	tdigit[0] = Q_low & 0x3ffffff;
+	tdigit[1] = 0;
+	QX = Q_low >> 26;
+	QX32 = QX;
+	nzeros = 0;
+
+	for (j = 0; QX32; j++, QX32 >>= 7) {
+	  k = (QX32 & 127);
+	  tdigit[0] += convert_table[j][k][0];
+	  tdigit[1] += convert_table[j][k][1];
+	  if (tdigit[0] >= 100000000) {
+	    tdigit[0] -= 100000000;
+	    tdigit[1]++;
 	  }
-
-	  if (tdigit[1] >= 100000000) {
-	    tdigit[1] -= 100000000;
-	    if (tdigit[1] >= 100000000)
-	      tdigit[1] -= 100000000;
-	  }
-
-	  digit = tdigit[0];
-	  if (!digit && !tdigit[1])
-	    nzeros += 16;
-	  else {
-	    if (!digit) {
-	      nzeros += 8;
-	      digit = tdigit[1];
-	    }
-	    // decompose digit
-	    PD = (UINT64) digit *0x068DB8BBull;
-	    digit_h = (UINT32) (PD >> 40);
-	    digit_low = digit - digit_h * 10000;
-
-	    if (!digit_low)
-	      nzeros += 4;
-	    else
-	      digit_h = digit_low;
-
-	    if (!(digit_h & 1))
-	      nzeros +=
-		3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
-			      (digit_h & 7));
-	  }
-
-	  if (nzeros) {
-	    // get P*(2^M[extra_digits])/10^extra_digits
-	    __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
-
-	    // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
-	    amount = recip_scale[nzeros];
-	    __shr_128 (CQ, Qh, amount);
-	  }
-	  diff_expon += nzeros;
-
 	}
+
+	if (tdigit[1] >= 100000000) {
+	  tdigit[1] -= 100000000;
+	  if (tdigit[1] >= 100000000)
+	    tdigit[1] -= 100000000;
+	}
+
+	digit = tdigit[0];
+	if (!digit && !tdigit[1])
+	  nzeros += 16;
+	else {
+	  if (!digit) {
+	    nzeros += 8;
+	    digit = tdigit[1];
+	  }
+	  // decompose digit
+	  PD = (UINT64) digit *0x068DB8BBull;
+	  digit_h = (UINT32) (PD >> 40);
+	  digit_low = digit - digit_h * 10000;
+
+	  if (!digit_low)
+	    nzeros += 4;
+	  else
+	    digit_h = digit_low;
+
+	  if (!(digit_h & 1))
+	    nzeros +=
+	      3 & (UINT32) (packed_10000_zeros[digit_h >> 3] >>
+			    (digit_h & 7));
+	}
+
+	if (nzeros) {
+	  // get P*(2^M[extra_digits])/10^extra_digits
+	  __mul_128x128_high (Qh, CQ, reciprocals10_128[nzeros]);
+
+	  // now get P/10^extra_digits: shift Q_high right by M[extra_digits]-128
+	  amount = recip_scale[nzeros];
+	  __shr_128 (CQ, Qh, amount);
+	}
+	diff_expon += nzeros;
+
       }
     }
-    if(diff_expon>=0){
-      res =
-	fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
-				 rnd_mode, pfpsf);
+	  }
+	if(diff_expon>=0){
+    res =
+      fast_get_BID64_check_OF (sign_x ^ sign_y, diff_expon, CQ.w[0],
+			       rnd_mode, pfpsf);
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
-      (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
+    (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-      // restore the rounding mode back if it has been changed
-      if (rm_changed) fesetround(old_rm);
-      BID_RETURN (res);
-    }
+    BID_RETURN (res);
+	}
   }
 #endif
 
@@ -1891,8 +1772,6 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
   } else {
     // UF occurs
@@ -1909,9 +1788,8 @@ if (!done) {
 #ifdef UNCHANGED_BINARY_STATUS_FLAGS
     (void) fesetexceptflag (&binaryflags, FE_ALL_FLAGS);
 #endif
-    // restore the rounding mode back if it has been changed
-    if (rm_changed) fesetround(old_rm);
     BID_RETURN (res);
+
   }
 
 }
